import OFS.PropertySheets
from ComputedAttribute import ComputedAttribute
from Globals import default__class_init__
from ZClasses.Property import klass_sequence


class VirtualSheets(OFS.PropertySheets.PropertySheets):

    """Ensure that virtual propertysheets are included in sheets"""

    def __propsets__(self):
        propsets = self._get_defaults()+self.aq_parent._v_currentSheets
        r=[]
        for id in klass_sequence(self.__class__,'__propset_attrs__').keys():
            r.append(getattr(self,id))
        return propsets+tuple(r)

    def manage_addPropertySheet(self, id, ns):
        """ """
        if self.aq_parent._addPropertySheet(id,ns):
            return 'OK'

    def manage_delPropertySheet(self, name='', xmlns=''):
        """ """
        self.aq_parent._delPropertySheet(name,xmlns)
        return 'OK'

    __ac_permissions__ = (
        ("Manage properties",
            ('manage_addPropertySheet','manage_delPropertySheet')
        ),
    )

    _implements_the_notional_subclassable_propertysheet_class_interface=1

    def propertyLabel(self,id):
        return id   # Hack to make sheets UI work
        
default__class_init__(VirtualSheets)


def SheetAttribute(name='',xmlns=''):
	def getsheet(self,name=name,xmlns=xmlns):
		return self.PropertySheet(name=name,xmlns=xmlns)
	return ComputedAttribute(getsheet)

